<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item :label="systemName+'号'" prop="usercode">
        <el-input
            v-model="queryParams.usercode"
            :placeholder="'请输入'+systemName+'号'"
            clearable
            @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="手机号" prop="mobile">
        <el-input
            v-model="queryParams.mobile"
            placeholder="请输入手机号"
            clearable
            @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['cai:anchor:add']"
        >新增</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="anchorList" @selection-change="handleSelectionChange">
<!--      <el-table-column type="selection" width="55" align="center" />-->
      <el-table-column :label="systemName+'号'" align="center" prop="usercode" />
      <el-table-column label="昵称" align="center" prop="nickname" />
      <el-table-column label="手机" align="center" prop="mobile" width="120"/>
      <el-table-column label="头像" align="center" prop="avatar" >
        <template v-slot="scope">
          <image-avatar :src="scope.row.avatar"/>
        </template>
      </el-table-column>
      <el-table-column label="性别" align="center" prop="gender">
        <template v-slot="scope">
          <cai-dict-tag :options="genderList" :value="scope.row.gender" />
        </template>
      </el-table-column>
      <el-table-column label="年龄" align="center" prop="age" />
      <el-table-column label="所在城市" align="center" prop="city" />
      <el-table-column label="开启视频" align="center" prop="openVideoStatus" >
        <template v-slot="scope">
          <el-switch
              v-model="scope.row.openVideoStatus"
              :active-value="1"
              :inactive-value="0"
              @change="handleOpenVideoStatusChange(scope.row)"
          ></el-switch>
        </template>
      </el-table-column>
      <el-table-column label="视频状态" align="center" prop="videoStatus" >
        <template v-slot="scope">
          <cai-dict-tag :options="videoStatusList" :value="scope.row.videoStatus" />
        </template>
      </el-table-column>
      <el-table-column label="首页展示" align="center" prop="indexDisplay" >
        <template v-slot="scope">
          <el-switch
              v-model="scope.row.indexDisplay"
              :active-value="1"
              :inactive-value="0"
              @change="handleIndexDisplayChange(scope.row)"
          ></el-switch>
        </template>
      </el-table-column>
      <el-table-column label="推荐" align="center" prop="recommendStatus" >
        <template v-slot="scope">
          <el-switch
              v-model="scope.row.recommendStatus"
              :active-value="1"
              :inactive-value="0"
              @change="handleRecommendStatusChange(scope.row)"
          ></el-switch>
        </template>
      </el-table-column>
      <el-table-column label="评分" align="center" prop="giveScore" />
<!--      <el-table-column label="视频分成" align="center" prop="videoRate" />
      <el-table-column label="守护分成" align="center" prop="guardRate" />
      <el-table-column label="礼物分成" align="center" prop="giftRate" />-->
      <el-table-column label="服务总次数" align="center" prop="serviceCount" />
      <el-table-column label="服务总时长" align="center" prop="serviceTime" />
      <el-table-column label="状态" align="center" prop="status" >
        <template v-slot="scope">
          <cai-dict-tag :options="userStatusList" :value="scope.row.status" />
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" fixed="right" width="180">
        <template v-slot="scope">
          <el-button
              size="mini"
              type="text"
              icon="el-icon-info"
              @click="handleAnchorInfo(scope.row)"
              v-hasPermi="['cai:anchor:query']"
          >详情</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['cai:anchor:edit']"
          >修改</el-button>
          <el-button
              size="mini"
              type="text"
              icon="el-icon-delete"
              @click="handleDelete(scope.row)"
              v-hasPermi="['cai:anchor:remove']"
          >取消</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <add-anchor-dialog v-if="addAnchorDialogVisible" ref="addAnchorDialog" @refreshDataList="getList"  />
    <update-anchor-dialog v-if="updateAnchorDialogVisible" ref="updateAnchorDialog" @refreshDataList="getList" />
    <anchor-info-dialog v-if="anchorInfoDialogVisible" ref="anchorInfoDialog" />
  </div>
</template>

<script>
import {delAnchor, listAnchor, updateAnchor} from '@/api/cai/anchor'
import {genderList, userStatusList, videoStatusList} from '@/constant/statusMap'
import AddAnchorDialog from "@/views/cai/anchor/add-anchor-dialog";
import UpdateAnchorDialog from "@/views/cai/anchor/update-anchor-dialog";
import AnchorInfoDialog from "@/views/cai/anchor/anchor-info-dialog";

export default {
  name: "Anchor",
  components:{
    AddAnchorDialog,UpdateAnchorDialog,AnchorInfoDialog
  },
  data() {
    return {
      genderList,userStatusList,videoStatusList,
      systemName: process.env.VUE_APP_SYSTEM_HOME,
      addAnchorDialogVisible: false,
      updateAnchorDialogVisible: false,
      anchorInfoDialogVisible: false,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 女神列表表格数据
      anchorList: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        usercode: undefined,
        mobile: undefined
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询女神列表列表 */
    getList() {
      this.loading = true;
      listAnchor(this.queryParams).then(response => {
        this.anchorList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    handleAdd(row) {
      this.addAnchorDialogVisible = true
      this.$nextTick(() => {
        this.$refs.addAnchorDialog.init(row?.usercode)
      })
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.updateAnchorDialogVisible = true
      this.$nextTick(() => {
        this.$refs.updateAnchorDialog.init(row)
      })
    },
    handleAnchorInfo(row){
      this.anchorInfoDialogVisible = true
      this.$nextTick(() => {
        this.$refs.anchorInfoDialog.init(row.userId)
      })
    },
    handleOpenVideoStatusChange(row){
      let text = row.openVideoStatus === 0 ? '封禁' : '恢复'
      this.$confirm('确认要' + text + '[' + row.nickname + ']开启视频吗?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        return updateAnchor({ id: row.id, openVideoStatus: row.openVideoStatus })
      }).then(() => {
        this.$modal.msgSuccess(text + '成功')
      }).catch(function() {
        row.openVideoStatus = row.openVideoStatus === 1 ? 0 : 1
      })
    },
    handleIndexDisplayChange(row){
      let text = row.indexDisplay === 0 ? '封禁' : '恢复'
      this.$confirm('确认要' + text + '[' + row.nickname + ']首页展示吗?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        return updateAnchor({ id: row.id, indexDisplay: row.indexDisplay })
      }).then(() => {
        this.$modal.msgSuccess(text + '成功')
      }).catch(function() {
        row.indexDisplay = row.indexDisplay === 1 ? 0 : 1
      })
    },
    handleRecommendStatusChange(row){
      let text = row.recommendStatus === 0 ? '封禁' : '恢复'
      this.$confirm('确认要' + text + '[' + row.nickname + ']是否被推荐吗?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        return updateAnchor({ id: row.id, recommendStatus: row.recommendStatus })
      }).then(() => {
        this.$modal.msgSuccess(text + '成功')
      }).catch(function() {
        row.recommendStatus = row.recommendStatus === 1 ? 0 : 1
      })
    },
    handleDelete(row) {
      this.$modal.confirm('是否确认取消"' + row.nickname + '"的主播？').then(() => {
        this.loading = true;
        return delAnchor(row.userId);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("取消成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
  }
};
</script>
